/*	:*****************************************************************
	:	"cnslib.h"	:	systemgPridehR\[ECu
	:*****************************************************************
*/
#ifndef	_CNS_H
#define	_CNS_H

#ifndef	_GUIDEFS_H
#	include	"guidefs.h"
#endif

typedef	struct	_cnslin_t
{	struct _cnslin_t	*next;
	struct _cnslin_t	*prev;
	size_t				len;
	size_t				ln;		/* \s		*/
	char				p[1];
} CNSLIN_T;

typedef	struct					/* eLXgʒu\	*/
{	size_t		lnL;			/* sԍi_j		*/
	size_t		lnD;			/* sԍ (\)		*/
	size_t		lnDn;			/* 擪(\)sԍ		*/
	size_t		ofs;			/* s̃ItZbg	*/
} CNSPOS_T;

#define	CNS_COLTBL_NUM	(32)

typedef	struct _cns_t
{
	int			page;			/* ݃y[W			*/
	FRAME		fr;				/* \W					*/
	FRAME		tFr;			/* \͈				*/
	COLOR		colTbl[CNS_COLTBL_NUM];
								/* J[e[u			*/

	void	*ptr;								/* ėp|C^		*/
	void (*sttDsp_func)(struct _cns_t *);		/* ԕ\p֐	*/
	int  (*extCmd_func)(struct _cns_t *,int);	/* gR}h֐	*/

	void (*scnFlushFunc)(struct _cns_t *,int,int);	/* not use	*/
	void (*dspLineFunc)(struct _cns_t *,int,int);	/* not use	*/

	void (*putSpcFunc)(struct _cns_t *,int,int,int);
	void (*putAnkFunc)(struct _cns_t *,int,int,int);
	void (*putKanFunc)(struct _cns_t *,int,int,int);
	void (*putCtrFunc)(struct _cns_t *,int,int,int);
	void (*putMakFunc)(struct _cns_t *,int,int,int);

	UCHAR		fntX,fntY;		/* tHgTCY			*/
	UCHAR		spcX,spcY;		/* 						*/
	SHORT		xsL;			/* iE}[Wj	*/
	SHORT		xsD;			/* \				*/
	SHORT		xofs;			/* \Jnʒu			*/
	SHORT		tab;			/* ^uTCY				*/
	SHORT		dspXc, dspYc;	/* \\			*/
	SHORT		dspXm, dspYm;

	CNSLIN_T	*topLin;		/* obt@擪				*/
	CNSLIN_T	*lastLin;		/* ŏIC				*/

	CNSLIN_T	*dspLin;		/* \擪					*/
	CNSPOS_T	 dspPos;		/* \擪ʒu				*/

	size_t		 txtSize;		/* eLXgTCY			*/
	size_t		 linMaxD;		/* \s					*/
	size_t		 linMaxL;		/* _s					*/

	CNSLIN_T	*curLin;		/* J[\s				*/
	CNSPOS_T	 curPos;		/* J[\ʒu				*/

	SHORT		 curXm;			/* J[\z[hʒu		*/
	SHORT		 curX, curY;	/* J[\ʒu				*/
	char		 curDsp;		/* J[\\			*/
	char		 curDmy;		/* TDP Ŏgp(underline)	*/
	char		_curDmy[2];

	char		 selFlag;		/* I					*/
	char		 selMode;		/* I[h				*/
	SHORT		 selX;			/* `IJnX			*/
	CNSLIN_T	*selLin;		/* IJn s|C^		*/
	CNSPOS_T	 selPos;		/* I擪ʒu				*/

	CNSPOS_T	lastTouch;		/* ŏIύXʒu				*/

	UINT		 findAtt;		/* 					*/
	CNSLIN_T	*findLin;		/* s|C^			*/
	CNSPOS_T	 findPos;		/* 擪					*/
	size_t		 findLen;		/* 				*/
	char		*searchStr;		/* 				*/
	size_t		searchLen;

	size_t		 homeY;			/* z[ʒu				*/

	int			logFlag;
	int			kanCode;		/* PoCgR[h		*/
	int			escRevers;		/* o[X					*/
	int			escLevel;		/* GXP[vV[PX		*/
	int			escCode;		/* GXP[vR[h			*/

	size_t		maxLinBuf;		/* R\[[hős	*/
	size_t		linBufSize;		/* sobt@̕		*/
	int			cnsX, cnsY;		/* R\[͈ʒu		*/
	int			cnsDspIgnore;	/* \֎~					*/
	int			cnsSelStr;		/* \p̃[N			*/
} CNS_T;

#define	CNS_PUTSPC(_cns,_x,_y,_ch)	{	\
	if ( !((_cns)->cnsDspIgnore) && ((_cns)->cnsY >= (_cns)->dspPos.lnD) && ((_y) < (_cns)->dspPos.lnD + (_cns)->dspYm) )	\
		((_cns)->putSpcFunc)((_cns),(_x),(_y),(_ch)&0xFF);	\
}
#define	CNS_PUTANK(_cns,_x,_y,_ch)	{	\
	if ( !((_cns)->cnsDspIgnore) && ((_cns)->cnsY >= (_cns)->dspPos.lnD) && ((_y) < (_cns)->dspPos.lnD + (_cns)->dspYm) )	\
		((_cns)->putAnkFunc)((_cns),(_x),(_y),(_ch)&0xFF);	\
}
#define	CNS_PUTKAN(_cns,_x,_y,_ch)	{	\
	if ( !((_cns)->cnsDspIgnore) && ((_cns)->cnsY >= (_cns)->dspPos.lnD) && ((_y) < (_cns)->dspPos.lnD + (_cns)->dspYm) )	\
		((_cns)->putKanFunc)((_cns),(_x),(_y),(_ch)&0xFFFF);	\
}
#define	CNS_PUTCTR(_cns,_x,_y,_ch)	{	\
	if ( !((_cns)->cnsDspIgnore) && ((_cns)->cnsY >= (_cns)->dspPos.lnD) && ((_y) < (_cns)->dspPos.lnD + (_cns)->dspYm) )	\
		((_cns)->putCtrFunc)((_cns),(_x),(_y),(_ch)&0xFF);	\
}
#define	CNS_PUTMAK(_cns,_x,_y,_ch)	{	\
	if ( !((_cns)->cnsDspIgnore) && ((_cns)->cnsY >= (_cns)->dspPos.lnD) && ((_y) < (_cns)->dspPos.lnD + (_cns)->dspYm) )	\
		((_cns)->putMakFunc)((_cns),(_x),(_y),(_ch)&0xFF);	\
}

/*	"cns010.c"		------------------------------------------------*/
extern	int		CNS_set_dspFunc( CNS_T *cns );
extern	CNS_T	*CNS_open(void);
extern	void	CNS_close( CNS_T *cns );

/*	"cns011.c"		------------------------------------------------*/
extern	int		CNS_getMarginAdjust( CNS_T *cns );
extern	void	CNS_setScnWork( CNS_T *cns );
extern	int		CNS_setScnSize( CNS_T *cns, int x1, int y1, int x2, int y2 );

/*	"cns012.c"		------------------------------------------------*/
extern	int		CNS_changeScnSize( CNS_T *cns, int x1, int y1, int x2, int y2 );

/*	"cns013.c"		------------------------------------------------*/
extern	int		CNS_clearBuffer( CNS_T *cns );

/*	"cns014.c"		------------------------------------------------*/
extern	int			CNS_getStrXY( CNS_T *cns, char *buf, int len, int x, int y );
extern	CNSLIN_T	*CNS_getLinPtr( CNS_T *cns, int lnD );

/*	"cnssetc.c"		------------------------------------------------*/
int		CNS_setc( CNS_T *cns, int x, int y, int ch );

/*	"cnsputc.c"		------------------------------------------------*/
extern	void	CNS_chkScroll( CNS_T *cns );
extern	void	CNS_putAnk( CNS_T *cns, int x, int y, int ch );
extern	void	CNS_putKan(CNS_T *cns, int x, int y, int sjis);
extern	int		CNS_putc( CNS_T *cns, int ch );

/*	"cnsputs.c"		------------------------------------------------*/
extern	int		CNS_puts( CNS_T *cns, CONST char *s);

/*	"cnsflush.c"	------------------------------------------------*/
extern	int		CNS_flush( CNS_T *cns, int dspLn, int dspN );

/*	"cnsjump.c"		------------------------------------------------*/
extern	int		CNS_jump( CNS_T *cns, size_t lnD );

/*	"cnsnext.c"		------------------------------------------------*/
extern	int		CNS_nextLine( CNS_T *cns, int n );

/*	"cnsprev.c"		------------------------------------------------*/
extern	int		CNS_prevLine( CNS_T *cns, int n );

/*	"cnscur.c"		------------------------------------------------*/
extern	void	CNS_putCursor( CNS_T *cns, int on_off );

#endif
